import { ElementRef, EventEmitter, KeyValueDiffers, NgZone, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { EditorView } from '@codemirror/view';
import { LanguageDescription } from '@codemirror/language';
import { Extension } from '@codemirror/state';
import * as i0 from "@angular/core";
export interface NgCodeMirrorOptions {
    mode: string | {
        name: string;
        value: string;
    };
    theme?: Theme;
    lineNumbers?: boolean;
    readonly?: boolean;
    autofocus?: boolean;
    lineWiseCopyCut?: boolean;
    lineWrapping?: boolean;
    cursorBlinkRate?: number;
}
export declare const selectableLanguages: {
    name: string;
    value: string;
}[];
export declare const External: import("@codemirror/state").AnnotationType<boolean>;
export type Theme = 'light' | 'dark' | 'material' | Extension;
export declare class CodeMirrorComponent implements OnInit, ControlValueAccessor, OnChanges, OnDestroy {
    private elementRef;
    private ngZone;
    private _differs;
    private _codemirrorContentObserver;
    private value;
    private onTouchedCallback;
    private onChangeCallback;
    options: NgCodeMirrorOptions;
    extensions: Extension[];
    languages: LanguageDescription[];
    focusChange: EventEmitter<boolean>;
    textAreaRef: ElementRef;
    codemirrorClassName: boolean;
    view?: EditorView;
    private _differ;
    private _readonlyConf;
    private _themeConf;
    private _placeholderConf;
    private _indentWithTabConf;
    private _indentUnitConf;
    private _lineWrappingConf;
    private _highlightWhitespaceConf;
    private _languageConf;
    private _updateListener;
    constructor(elementRef: ElementRef, ngZone: NgZone, _differs: KeyValueDiffers);
    ngOnInit(): void;
    ngOnChanges(simpleChanges: SimpleChanges): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    writeValue(value: string): void;
    initializeCodemirror(): void;
    setOptionIfChanged(optionName: string, newValue: any): void;
    setLineWrapping(value: boolean): void;
    setExtensions(value: Extension[]): void;
    setValue(value: string): void;
    setReadonly(value: boolean): void;
    setLanguage(lang: string | {
        name: string;
        value: string;
    }): void;
    setCursor(cursorBlinkRate: number): void;
    setTheme(value: Theme): void;
    private _dispatchEffects;
    private _findLanguage;
    private _getAllExtensions;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CodeMirrorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CodeMirrorComponent, "ng-codemirror, [ngCodeMirror]", never, { "options": { "alias": "options"; "required": false; }; "extensions": { "alias": "extensions"; "required": false; }; "languages": { "alias": "languages"; "required": false; }; }, { "focusChange": "focusChange"; }, never, never, true, never>;
}
